scp={}
--[[

	SCP-087-B	the horror game
	for CS2D
	by Bolt_PL (USGN#88318)
	Don't play it if you are nerves...
 
	Original SCP-087-B:
	http://www.mediafire.com/?25c13bc42b2j5ki

	Have fun ... if you know what I mean
]]--
function array(m)
        local array = {}
        for i = 1, m do
                array[i] = 0
        end
        return array
end
parse("mp_hud 1")
scp.sounds={"sfx/scp/ambient1.ogg","sfx/scp/proceed.ogg"}
scp.monsters={"sfx/scp/horror1.ogg","sfx/scp/horror2.ogg","sfx/scp/horror3.ogg"}
scp.chance=0
scp.random=0
scp.spotted=array(32,0)
scp.monster=array(32,0)
scp.score=array(32,0)
scp.levels=array(32,0)
scp.spawns={{28,13},{8,40},{34,44}}
scp.hud=array(32,0)

function snd(id,path)
	parse('sv_sound2 '..id..' '..""..path..""..'')
end
function scp.death(id)
	msg2(id,"You have been ... destroyed@C")
	msg(">"..player(id,"name").." finished life with score: "..scp.score[id].."monsters on "..scp.levels[id].." levels.")
	scp.spotted[id]=0
	freeimage(scp.monster[id])
	scp.monster[id]=0
	scp.score[id]=0
	scp.levels[id]=0
end

addhook("ms100","scp.ms")
function scp.ms()
	scp.chance=math.random(1,10)
	scp.random=math.random(1,scp.chance)
	for _,id in pairs(player(0,"tableliving")) do
		if scp.spotted[id]==1 then
			local hp=player(id,"health")-5
			parse("sethealth "..id.." "..hp.."")
			if hp<=0 then
				scp.death(id)
				snd(id,"sfx/scp/death.ogg")
			end 
		else
			local hp=player(id,"health")+5
			if hp<100 then
				parse("sethealth "..id.." "..hp.."") 
			end
		end
	end
end

addhook("movetile","scp.move")
function scp.move(id,x,y)
		if entity(x,y,"name")=="start" then
			if scp.random==1 then
				scp.spotted[id]=1
				local random=math.random(1,3)
				snd(id,scp.monsters[random])
				scp.monster[id]=image("gfx/scp/monster.bmp",320,240,2,id)
			else
				local random=math.random(1,2)
				snd(id,scp.sounds[random])
			end
		end
		if entity(x,y,"name")=="reset" then
				if scp.spotted[id]==1 then
					scp.spotted[id]=0
					freeimage(scp.monster[id])
					scp.score[id]=scp.score[id]+1
				end
		end
		if entity(x,y,"name")=="next" then
				local next=math.random(1,3)
				parse("setpos "..id.." "..scp.spawns[next][1].." "..scp.spawns[next][2].."")
				scp.levels[id]=scp.levels[id]+1
		end
end
addhook("spawn","scp.spawn")
function scp.spawn(id)
	parse("strip "..id.." 50")
	freeimage(scp.hud[id])
	freeimage(scp.monster[id])
	scp.hud[id]=image("gfx/scp/hud.bmp",320,240,2,id)
end